<template>
  <JDraggable
    v-slot="dragProps"
    :initial-top="initialPosition.top"
    :initial-left="initialPosition.left"
  >
    <JResizer
      v-slot="resizerProps"
      axis-y
      v-bind="$attrs"
      hide-strip
      min-resize
    >
      <ConversationDetails
        v-bind="resizerProps"
        :chat-id="chatId"
        class="conversation-details"
      >
        <template #header="{ chat }">
          <div
            v-bind="dragProps"
            class="drag-drop-wrapper"
          >
            <ConversationDetailsHeader :chat="chat">
              <div class="dialog-actions">
                <JActionIcon
                  size="xs"
                  class="drag-icon"
                >
                  <JIcon
                    icon="drag"
                    size="16px"
                  />
                </JActionIcon>
                <JDialogCloseIcon
                  @keydown.enter="$dialog.close(dialogId)"
                  @keydown.space="$dialog.close(dialogId)"
                  @click="$dialog.close(dialogId)"
                />
              </div>
            </ConversationDetailsHeader>
          </div>
        </template>
      </ConversationDetails>
    </JResizer>
  </JDraggable>
</template>

<script setup lang="ts">
import { inject } from 'vue';
import { DialogPlugin } from '@new-jira-clone/ui/src/plugins/dialog';
import {
  JDraggable, JResizer, JDialogCloseIcon, JActionIcon, JIcon,
} from '@new-jira-clone/ui/src/components';
import ConversationDetails from './ConversationDetails.vue';
import ConversationDetailsHeader from './ConversationDetailsHeader.vue';

defineProps({
  dialogId: {
    type: Number,
    default: null,
  },
  chatId: {
    type: String,
    default: null,
  },
});

const $dialog = inject('$dialog') as DialogPlugin;
const initialPosition = $dialog.getInitialNonModalDialogPosition();
</script>

<style scoped lang="scss">
.conversation-details {
  z-index: 1 !important;
  min-width: 70px;
  width: 430px;
  min-height: 70px;
  height: 530px;
  max-height: 1000px;
  font-size: 14px;
  border-radius: 6px;
  overflow: hidden;
  background-color: var(--j-app-bg);
  box-shadow: 0 11px 15px -7px #0003, 0 24px 38px 3px #00000024, 0 9px 46px 8px #0000001f;
}

.drag-drop-wrapper {
  width: 100%;
}

.dialog-actions {
  display: flex;

  .drag-icon {
    cursor: grabbing;
  }
}
</style>
